#include "stdafx.h"

#include "EntryPoint.h"
#include "Common.h"
#include "Settings.h"

using namespace EmergencyStrobes;
using namespace System::Windows::Forms;
using namespace System::Threading;

void EntryPoint::Main()
{
	Settings::InitializeINIFile();

	while (Game::IsLoading)
		GameFiber::Yield();

	Game::LogTrivial("Emergency Strobes v" + Common::GetCurrentVersion() + " loaded");

	manualActivate = false;
	autoActivate = false;
	finishedHeadlightsFlash = true;
	playerVeh = Game::LocalPlayer->Character->CurrentVehicle;
	Game::LocalPlayer;
	if (Settings::AreHeadlightsEnabled) 
	{
		GameFiber::StartNew(gcnew ThreadStart(&EntryPoint::HeadlightsController), "Headlights Fiber");
	}

	if (Settings::AreIndicatorLightsEnabled)
	{
		GameFiber::StartNew(gcnew ThreadStart(&EntryPoint::IndicatorLightsController), "Indicator lights Fiber");
	}

	while (true)
	{
		GameFiber::Yield();

		if (Game::LocalPlayer->Character->IsInAnyVehicle(false)) 
		{
			playerVeh = Game::LocalPlayer->Character->CurrentVehicle;
		}
		else if (Settings::StayOnWhenExitVehicle)
		{
			playerVeh = Game::LocalPlayer->Character->LastVehicle;
		}
		else if(!Settings::StayOnWhenExitVehicle && playerVeh != nullptr)
		{
			ResetPlayerVehicleLights();
			playerVeh = nullptr;
		}
		else
		{
			playerVeh = nullptr;
		}

		if (Settings::ModifierKey == Keys::None)
		{
			if (!autoActivate && Game::IsKeyDown(Settings::ToggleKey))
				manualActivate = !manualActivate;
		}
		else
		{
			if (!autoActivate && Game::IsKeyDownRightNow(Settings::ModifierKey) && Game::IsKeyDown(Settings::ToggleKey))
				manualActivate = !manualActivate;
		}

		if (!autoActivate && Settings::ToggleWithSirenOn && playerVeh != nullptr && EntityExtensions::Exists(playerVeh) && playerVeh->IsSirenOn)
		{
			autoActivate = true;
		}
		else if(autoActivate  && playerVeh != nullptr && EntityExtensions::Exists(playerVeh) && !playerVeh->IsSirenOn)
		{
			autoActivate = false;
		}

		if (autoActivate && playerVeh != nullptr && EntityExtensions::Exists(playerVeh) && playerVeh->IsSirenOn)
		{
			if (Settings::ModifierKey == Keys::None)
			{
				if (Game::IsKeyDown(Settings::ToggleKey))
					disableAutoActivateManually = !disableAutoActivateManually;
			}
			else
			{
				if (Game::IsKeyDownRightNow(Settings::ModifierKey) && Game::IsKeyDown(Settings::ToggleKey))
					disableAutoActivateManually = !disableAutoActivateManually;
			}
		}

		if (disableAutoActivateManually && playerVeh != nullptr && EntityExtensions::Exists(playerVeh) && !playerVeh->IsSirenOn)
		{
			disableAutoActivateManually = false;
		}


		if (!autoActivate && !manualActivate && finishedHeadlightsFlash && playerVeh != nullptr && EntityExtensions::Exists(playerVeh))
		{
			isLeftHeadlightBroken = Common::IsVehicleLeftHeadlightBroken(playerVeh);
			isRightHeadlightBroken = Common::IsVehicleRightHeadlightBroken(playerVeh);
		}
	}
}

void EntryPoint::HeadlightsController()
{
	int headlightsInt = 0;
	while (true)
	{
		GameFiber::Yield();

		if (playerVeh != nullptr && EntityExtensions::Exists(playerVeh) && (playerVeh->HasSiren || Settings::UseInAllVehicles))
		{
			if ((autoActivate || manualActivate) && !disableAutoActivateManually)
			{
				finishedHeadlightsFlash = false;

				isLeftHeadlightDeformated = Common::GetVehicleDeformationAtFrontLeft(playerVeh).Length() > 0.01225f;
				isRightHeadlightDeformated = Common::GetVehicleDeformationAtFrontRight(playerVeh).Length() > 0.01225f;

				NativeFunction::CallByName<unsigned int>((String ^)"SET_VEHICLE_LIGHT_MULTIPLIER", gcnew array<NativeArgument^> { playerVeh, Settings::HeadlightsBrightness });
				NativeFunction::CallByName<unsigned int>((String ^)"SET_VEHICLE_LIGHTS", gcnew array<NativeArgument^> { playerVeh, 2 });
				if (headlightsInt % 2 == 0)
				{
					Common::SetVehicleLeftHeadlightBroken(playerVeh, true);

					if (!isRightHeadlightBroken && !isRightHeadlightDeformated)
						Common::SetVehicleRightHeadlightBroken(playerVeh, false);
				}
				else
				{
					if (!isLeftHeadlightBroken && !isLeftHeadlightDeformated)
						Common::SetVehicleLeftHeadlightBroken(playerVeh, false);

					Common::SetVehicleRightHeadlightBroken(playerVeh, true);
				}
				headlightsInt++;
				playerVeh->IsEngineOn = true;
				GameFiber::Sleep(Settings::HeadlightsInterval);
			}
			else if (playerVeh != nullptr && EntityExtensions::Exists(playerVeh) && headlightsInt != 0)
			{
				headlightsInt = 0;

				if (!isLeftHeadlightBroken && !isRightHeadlightDeformated)
					Common::SetVehicleLeftHeadlightBroken(playerVeh, false);
				if (!isRightHeadlightBroken && !isRightHeadlightDeformated)
					Common::SetVehicleRightHeadlightBroken(playerVeh, false);

				NativeFunction::CallByName<unsigned int>((String ^)"SET_VEHICLE_LIGHTS", gcnew array<NativeArgument^> { playerVeh, 0 });
				NativeFunction::CallByName<unsigned int>((String ^)"SET_VEHICLE_LIGHT_MULTIPLIER", gcnew array<NativeArgument^> { playerVeh, 1.0f });

				finishedHeadlightsFlash = true;
			}
		}
	}
}


void EntryPoint::IndicatorLightsController()
{
	int indicatorlightsInt = 0;
	while (true)
	{
		GameFiber::Yield();

		if (playerVeh != nullptr && EntityExtensions::Exists(playerVeh) && (playerVeh->HasSiren || Settings::UseInAllVehicles))
		{
			if ((autoActivate || manualActivate) && !disableAutoActivateManually)
			{
				if (indicatorlightsInt % 2 == 0)
				{
					playerVeh->IndicatorLightsStatus = VehicleIndicatorLightsStatus::LeftOnly;
				}
				else
				{
					playerVeh->IndicatorLightsStatus = VehicleIndicatorLightsStatus::RightOnly;
				}
				indicatorlightsInt++;
				GameFiber::Sleep(Settings::IndicatorLightsInterval);
			}
			else if (playerVeh != nullptr && EntityExtensions::Exists(playerVeh) && indicatorlightsInt != 0)
			{
				indicatorlightsInt = 0;
				playerVeh->IndicatorLightsStatus = VehicleIndicatorLightsStatus::Off;
			}

		}
	}
}


void EntryPoint::ResetPlayerVehicleLights()
{
	if (playerVeh != nullptr && EntityExtensions::Exists(playerVeh)) 
	{
		playerVeh->IndicatorLightsStatus = VehicleIndicatorLightsStatus::Off;

		if (!isLeftHeadlightBroken && !isRightHeadlightDeformated)
			Common::SetVehicleLeftHeadlightBroken(playerVeh, false);

		if (!isRightHeadlightBroken && !isRightHeadlightDeformated)
			Common::SetVehicleRightHeadlightBroken(playerVeh, false);

		NativeFunction::CallByName<unsigned int>((String ^)"SET_VEHICLE_LIGHTS", gcnew array<NativeArgument^> { playerVeh, 0 });
		NativeFunction::CallByName<unsigned int>((String ^)"SET_VEHICLE_LIGHT_MULTIPLIER", gcnew array<NativeArgument^> { playerVeh, 1.0f });
	}
}
