#pragma once

using namespace System;
using namespace System::Windows::Forms;
using namespace Rage;
using namespace Rage::Native;

namespace EmergencyStrobes
{
	public ref class Settings
	{
	public:
		static InitializationFile^ INIFile = nullptr;
		static void InitializeINIFile();
		static property Keys ModifierKey
		{
			Keys get()
			{
				return INIFile->ReadEnum<Keys>("General", "Modifier Key", Keys::LControlKey);
			}
		};
		static property Keys ToggleKey
		{
			Keys get()
			{
				return INIFile->ReadEnum<Keys>("General", "Manual Toggle Key", Keys::T);
			}
		};

		static  property bool ToggleWithSirenOn
		{
			bool get()
			{
				return INIFile->ReadBoolean("General", "Toggle With Siren On", true);
			}
		};

		static  property bool UseInAllVehicles
		{
			bool get()
			{
				return INIFile->ReadBoolean("General", "Use in all vehicles", false);
			}
		};

		static  property bool AreHeadlightsEnabled
		{
			bool get()
			{
				return INIFile->ReadBoolean("General", "Enable Headlights", true);
			}
		};

		static  property bool AreIndicatorLightsEnabled
		{
			bool get()
			{
				return INIFile->ReadBoolean("General", "Enable Indicator Lights", true);
			}
		};

		static property  int HeadlightsInterval 
		{
			int get()
			{
				return INIFile->ReadInt32("General", "Headlights Interval", 140);
			}
		}

		static  property int IndicatorLightsInterval
		{
			int get()
			{
				return INIFile->ReadInt32("General", "Indicator Lights Interval", 225);
			}
		}

		static  property float HeadlightsBrightness
		{
			float get()
			{
				return INIFile->ReadSingle("General", "Headlights Brightness", 20.0f);
			}
		}

		static  property bool StayOnWhenExitVehicle
		{
			bool get()
			{
				return INIFile->ReadBoolean("General", "Stay On When Exit Vehicle", false);
			}
		}
	};
}
